include "Java/java.grm"
include "Java/javaCommentOverrides.grm"
redefine field_declaration

    [comment_nl] ... 

end define
redefine modifier

    'abstract 
    |    'final 
    |    'public 
    |    'protected 
    |    'private 
    |    'static 
    |    'transient 
    |    'volatile 
    |    'native 
    |    'synchronized 
    |    'strictfp 
    |    [repeat annotation] 

end define
redefine program

    [package_declaration *] 

end define
redefine type_declaration

    [class_declaration]  [NL] [NL]
    [comment_nl] 
    |    [interface_declaration]  [NL] [NL]
    [comment_nl] 
    |    [enum_declaration]  [NL]
    [comment_nl] 

end define
redefine import_declaration

    [comment_nl]  'import  [opt  'static]  [imported_name]  ';  [NL]
    [comment_nl] 
    |    [comment_nl]  ';  [NL]
    [comment_nl] 

end define
redefine class_header

    [repeat modifier]  'class  [class_name]  [opt extends_clause]  [opt implements_clause] 

end define
redefine interface_header

    [repeat modifier]  [opt annot_marker]  'interface  [interface_name]  [opt extends_clause]  [opt implements_clause] 

end define
redefine enum_header

    [repeat modifier]  [opt id]  'enum  [opt declared_name]  [opt extends_clause]  [opt implements_clause] 

end define
redefine extends_clause

    'extends  [list type_name +] 

end define
redefine implements_clause

    'implements  [list qualified_name +] 

end define
redefine package_declaration

    [comment_nl]  [NL]
    [opt package_header]  [repeat import_declaration]  [repeat type_declaration] 

end define
redefine class_or_interface_body

    '{ [NL] [IN]
        [repeat class_body_declaration]  [EX] [NL]
    [comment_nl]  '}  [opt  ';]  [comment_nl]  [NL] [NL] 

end define
redefine constructor_declaration

            [NL]
    [repeat modifier]  [opt generic_parameter]  [constructor_declarator]  [opt throws]  [constructor_body]  [NL] [NL] 

end define
redefine variable_declaration

    [repeat modifier]  [type_specifier]  [variable_declarators]  ';  [NL] 

end define
redefine variable_declarators

    [list variable_declarator +] 

end define
redefine method_declaration

            [NL]
    [repeat modifier]  [opt generic_parameter]  [type_specifier]  [method_declarator]  [opt throws]  [method_body] 

end define
redefine throws

    'throws  [list qualified_name +] 

end define
redefine annotation_value_list

    [single_annotation_value] 
    |    [list keyed_annotation_value] 

end define
redefine single_annotation_value

    [expression] 
    |    [nested_annotation] 
    |    { [list expression_or_nested_annotation] } 

end define
redefine comment_nl

    [empty] 
    |    [repeat mycomment] 

end define
function contains Object  [any]
    match  *  [any]
        Object 
end function

function Private A  [class_body_declaration]
    match  [class_or_interface_body]
        B  [class_or_interface_body] 
    construct M  [modifier *]
        _  [^  A] 
    construct PublicModifiers  [modifier *]
        'public  'protected 
    where not
        M  [contains  each  PublicModifiers] end function

function SingleLine A  [mycomment]
    match  [comment_nl]
        B  [comment_nl] 
    construct S_Comment  [stringlit]
        _  [quote  A] 
    where
        S_Comment  [grep  "^//NON"] end function

function NotModel A  [class_body_declaration]
    match  [class_or_interface_body]
        B  [class_or_interface_body] 
    construct S_Cs  [stringlit]
        _  [quote  A] 
    where not
        S_Cs  [grep  "@model"] end function

keys
    <<<<<<  >>>>>> 
end keys

compounds
    <<<<<<  >>>>>> 
end compounds

define Change
            [NL]
    <<<<<<  [opt stringlit]  [NL]
    |  [NL]
    >>>>>>  [opt stringlit]  [NL]
 
end define
redefine package_header
    ...
|       
    [attr Change] 

end define
function find_replace_package_header
    replace  [program]
        P  [ program ] 
    import Program_Diff [program]

    construct S  [package_header *]
        _  [ find_clones_package_header  P  Program_Diff ] 
    construct P3  [program]
        P  [mark_clones_package_header  each  S]
 
    by
        P3 
end function

function find_clones_package_header P  [program] P2  [program]
    replace  [package_header *]
        _  [ package_header  * ] 
    construct S  [package_header *]
        _  [ ^  P ] 
    by
        _  [add_if_clones_package_header1  P2  each  S]
 
end function

function add_if_clones_package_header1 P2  [program] Stmt  [package_header]
    construct S2  [package_header *]
        _  [ ^  P2 ] 
    deconstruct * S2
        Stmt  Rest  [ package_header  * ] 
    replace  [package_header *]
        StructuredClones  [ package_header  * ] 
    deconstruct not * StructuredClones
        C  [attr Change] 
    by
        StructuredClones  [ . Stmt ] 
end function

function mark_clones_package_header S  [package_header]
    import CloneNumber [number]

    import Program_Diff [program]

    export CloneNumber
        CloneNumber  [ +  1 ] 
    construct C  [stringlit]
        _  [ quote  S ] 
    where not
        C  [=  ""]
    construct S2  [package_header]
        >>>>>>  C 
    export Program_Diff
        Program_Diff  [ $  S  S2 ] 
    replace  [program]
        P  [ program ] 
    construct S1  [package_header]
        <<<<<<  C 
    by
        P  [ $  S  S1 ] 
end function

redefine type_declaration
    ...
|       
    [attr Change] 

end define
function find_replace_type_declaration
    replace  [program]
        P  [ program ] 
    import Program_Diff [program]

    construct S  [type_declaration *]
        _  [ find_clones_type_declaration  P  Program_Diff ] 
    construct P3  [program]
        P  [mark_clones_type_declaration  each  S]
 
    by
        P3 
end function

function find_clones_type_declaration P  [program] P2  [program]
    replace  [type_declaration *]
        _  [ type_declaration  * ] 
    construct S  [type_declaration *]
        _  [ ^  P ] 
    by
        _  [add_if_clones_type_declaration1  P2  each  S]
 
end function

function add_if_clones_type_declaration1 P2  [program] Stmt  [type_declaration]
    construct S2  [type_declaration *]
        _  [ ^  P2 ] 
    deconstruct * S2
        Stmt  Rest  [ type_declaration  * ] 
    replace  [type_declaration *]
        StructuredClones  [ type_declaration  * ] 
    deconstruct not * StructuredClones
        C  [attr Change] 
    by
        StructuredClones  [ . Stmt ] 
end function

function mark_clones_type_declaration S  [type_declaration]
    import CloneNumber [number]

    import Program_Diff [program]

    export CloneNumber
        CloneNumber  [ +  1 ] 
    construct C  [stringlit]
        _  [ quote  S ] 
    where not
        C  [=  ""]
    construct S2  [type_declaration]
        >>>>>>  C 
    export Program_Diff
        Program_Diff  [ $  S  S2 ] 
    replace  [program]
        P  [ program ] 
    construct S1  [type_declaration]
        <<<<<<  C 
    by
        P  [ $  S  S1 ] 
end function

redefine class_body_declaration
    ...
|       
    [attr Change] 

end define
function find_replace_class_body_declaration
    replace  [program]
        P  [ program ] 
    import Program_Diff [program]

    construct S  [class_body_declaration *]
        _  [ find_clones_class_body_declaration  P  Program_Diff ] 
    construct P3  [program]
        P  [mark_clones_class_body_declaration  each  S]
 
    by
        P3 
end function

function find_clones_class_body_declaration P  [program] P2  [program]
    replace  [class_body_declaration *]
        _  [ class_body_declaration  * ] 
    construct S  [class_body_declaration *]
        _  [ ^  P ] 
    by
        _  [add_if_clones_class_body_declaration1  P2  each  S]
 
end function

function add_if_clones_class_body_declaration1 P2  [program] Stmt  [class_body_declaration]
    construct S2  [class_body_declaration *]
        _  [ ^  P2 ] 
    deconstruct * S2
        Stmt  Rest  [ class_body_declaration  * ] 
    replace  [class_body_declaration *]
        StructuredClones  [ class_body_declaration  * ] 
    deconstruct not * StructuredClones
        C  [attr Change] 
    by
        StructuredClones  [ . Stmt ] 
end function

function mark_clones_class_body_declaration S  [class_body_declaration]
    import CloneNumber [number]

    import Program_Diff [program]

    export CloneNumber
        CloneNumber  [ +  1 ] 
    construct C  [stringlit]
        _  [ quote  S ] 
    where not
        C  [=  ""]
    construct S2  [class_body_declaration]
        >>>>>>  C 
    export Program_Diff
        Program_Diff  [ $  S  S2 ] 
    replace  [program]
        P  [ program ] 
    construct S1  [class_body_declaration]
        <<<<<<  C 
    by
        P  [ $  S  S1 ] 
end function

redefine mycomment
    ...
|       
    [attr Change] 

end define
function find_replace_mycomment
    replace  [program]
        P  [ program ] 
    import Program_Diff [program]

    construct S  [mycomment *]
        _  [ find_clones_mycomment  P  Program_Diff ] 
    construct P3  [program]
        P  [mark_clones_mycomment  each  S]
 
    by
        P3 
end function

function find_clones_mycomment P  [program] P2  [program]
    replace  [mycomment *]
        _  [ mycomment  * ] 
    construct S  [mycomment *]
        _  [ ^  P ] 
    by
        _  [add_if_clones_mycomment1  P2  each  S]
 
end function

function add_if_clones_mycomment1 P2  [program] Stmt  [mycomment]
    construct S2  [mycomment *]
        _  [ ^  P2 ] 
    deconstruct * S2
        Stmt  Rest  [ mycomment  * ] 
    replace  [mycomment *]
        StructuredClones  [ mycomment  * ] 
    deconstruct not * StructuredClones
        C  [attr Change] 
    by
        StructuredClones  [ . Stmt ] 
end function

function mark_clones_mycomment S  [mycomment]
    import CloneNumber [number]

    import Program_Diff [program]

    export CloneNumber
        CloneNumber  [ +  1 ] 
    construct C  [stringlit]
        _  [ quote  S ] 
    where not
        C  [=  ""]
    construct S2  [mycomment]
        >>>>>>  C 
    export Program_Diff
        Program_Diff  [ $  S  S2 ] 
    replace  [program]
        P  [ program ] 
    construct S1  [mycomment]
        <<<<<<  C 
    by
        P  [ $  S  S1 ] 
end function

function normalise_ignore_by2_modifier_annotation1 E1  [modifier]
    replace  [modifier *]
        Seq  [modifier *] 
    deconstruct not E1
        X8  [repeat annotation] 
    by
        Seq  [ . E1 ] 
end function

function normalise_ignore_by3_modifier_annotation1 E1  [modifier]
    replace  [modifier *]
        Seq  [modifier *] 
    deconstruct E1
        X8  [repeat annotation] 
    by
        Seq 
end function

function normalise_ignore_by4_modifier_annotation1
    replace  [program]
        P1  [ program ] 
    construct List1  [modifier *]
        _  [ ^  P1 ] 
    construct List2  [modifier *]
        _  [normalise_ignore_by3_modifier_annotation1  each  List1]  [normalise_ignore_by2_modifier_annotation1  each  List1]
 
    construct P2  [program]
        P1  [ $  List1  List2 ] 
    by
        P2 
end function

rule normalise_list_class_header_modifier
    replace  [repeat modifier]
        N1  [modifier]  N2  [modifier]  Rest  [repeat modifier] 
    construct T1  [stringlit]
        _  [ quote  N1 ] 
    construct T2  [stringlit]
        _  [ quote  N2 ] 
    where
        T1  [>  T2]
    by
        N2  N1  Rest 
end rule

rule normalise_list_interface_header_modifier
    replace  [repeat modifier]
        N1  [modifier]  N2  [modifier]  Rest  [repeat modifier] 
    construct T1  [stringlit]
        _  [ quote  N1 ] 
    construct T2  [stringlit]
        _  [ quote  N2 ] 
    where
        T1  [>  T2]
    by
        N2  N1  Rest 
end rule

rule normalise_list_enum_header_modifier
    replace  [repeat modifier]
        N1  [modifier]  N2  [modifier]  Rest  [repeat modifier] 
    construct T1  [stringlit]
        _  [ quote  N1 ] 
    construct T2  [stringlit]
        _  [ quote  N2 ] 
    where
        T1  [>  T2]
    by
        N2  N1  Rest 
end rule

rule normalise_list_extends_clause_type_name
    replace  [list type_name +]
        N1  [type_name] ,  N2  [type_name] ,  Rest  [list type_name +] 
    construct T1  [stringlit]
        _  [ quote  N1 ] 
    construct T2  [stringlit]
        _  [ quote  N2 ] 
    where
        T1  [>  T2]
    by
        N2 ,  N1 ,  Rest 
end rule

rule normalise_list_implements_clause_qualified_name
    replace  [list qualified_name +]
        N1  [qualified_name] ,  N2  [qualified_name] ,  Rest  [list qualified_name +] 
    construct T1  [stringlit]
        _  [ quote  N1 ] 
    construct T2  [stringlit]
        _  [ quote  N2 ] 
    where
        T1  [>  T2]
    by
        N2 ,  N1 ,  Rest 
end rule

function normalise_ignore_by2_package_declaration_import_declaration2 E1  [package_declaration]
    replace  [package_declaration *]
        Seq  [package_declaration *] 
    deconstruct not E1
        X15  [comment_nl]  X16  [opt package_header]  X17  [repeat import_declaration]  X18  [repeat type_declaration] 
    by
        Seq  [ . E1 ] 
end function

function normalise_ignore_by3_package_declaration_import_declaration2 E1  [package_declaration]
    replace  [package_declaration *]
        Seq  [package_declaration *] 
    deconstruct E1
        X15  [comment_nl]  X16  [opt package_header]  X17  [repeat import_declaration]  X18  [repeat type_declaration] 
    construct E2  [package_declaration]
        X15  X16  X18 
    by
        Seq  [ . E2 ] 
end function

function normalise_ignore_by4_package_declaration_import_declaration2
    replace  [program]
        P1  [ program ] 
    construct List1  [package_declaration *]
        _  [ ^  P1 ] 
    construct List2  [package_declaration *]
        _  [normalise_ignore_by3_package_declaration_import_declaration2  each  List1]  [
                  normalise_ignore_by2_package_declaration_import_declaration2  each  List1]
 
    construct P2  [program]
        P1  [ $  List1  List2 ] 
    by
        P2 
end function

function normalise_ignore_by1_NotModel_class_or_interface_body_class_body_declaration1 E1  [class_or_interface_body] N1  [
  class_body_declaration]
    replace  [class_body_declaration *]
        Seq  [class_body_declaration *] 
    where not
        E1  [NotModel  N1]
    by
        Seq  [ . N1 ] 
end function

function normalise_ignore_by2_NotModel_class_or_interface_body_class_body_declaration1 E1  [class_or_interface_body] N1  [
  class_body_declaration]
    replace  [class_body_declaration *]
        Seq  [class_body_declaration *] 
    where
        E1  [NotModel  N1]
    by
        Seq 
end function

function normalise_ignore_by3_NotModel_class_or_interface_body_class_body_declaration1 E1  [class_or_interface_body]
    replace  [class_or_interface_body *]
        Seq  [class_or_interface_body *] 
    deconstruct E1
        '{ N1  [repeat class_body_declaration]  X23  [comment_nl]  '}  X24  [opt  ';]  X25  [comment_nl] 
    construct N2  [class_body_declaration *]
        _  [normalise_ignore_by1_NotModel_class_or_interface_body_class_body_declaration1  E1  each  N1]  [
                  normalise_ignore_by2_NotModel_class_or_interface_body_class_body_declaration1  E1  each  N1]
 
    construct E2  [class_or_interface_body]
        '{ N2  X23  '}  X24  X25 
    by
        Seq  [ . E2 ] 
end function

function normalise_ignore_by4_NotModel_class_or_interface_body_class_body_declaration1
    replace  [program]
        P1  [ program ] 
    construct List1  [class_or_interface_body *]
        _  [ ^  P1 ] 
    construct List2  [class_or_interface_body *]
        _  [normalise_ignore_by3_NotModel_class_or_interface_body_class_body_declaration1  each  List1]
 
    construct P2  [program]
        P1  [$  each  List1  List2]
 
    by
        P2 
end function

rule normalise_list_constructor_declaration_modifier
    replace  [repeat modifier]
        N1  [modifier]  N2  [modifier]  Rest  [repeat modifier] 
    construct T1  [stringlit]
        _  [ quote  N1 ] 
    construct T2  [stringlit]
        _  [ quote  N2 ] 
    where
        T1  [>  T2]
    by
        N2  N1  Rest 
end rule

rule normalise_list_variable_declaration_modifier
    replace  [repeat modifier]
        N1  [modifier]  N2  [modifier]  Rest  [repeat modifier] 
    construct T1  [stringlit]
        _  [ quote  N1 ] 
    construct T2  [stringlit]
        _  [ quote  N2 ] 
    where
        T1  [>  T2]
    by
        N2  N1  Rest 
end rule

rule normalise_list_variable_declarators_variable_declarator
    replace  [list variable_declarator +]
        N1  [variable_declarator] ,  N2  [variable_declarator] ,  Rest  [list variable_declarator +] 
    construct T1  [stringlit]
        _  [ quote  N1 ] 
    construct T2  [stringlit]
        _  [ quote  N2 ] 
    where
        T1  [>  T2]
    by
        N2 ,  N1 ,  Rest 
end rule

rule normalise_list_method_declaration_modifier
    replace  [repeat modifier]
        N1  [modifier]  N2  [modifier]  Rest  [repeat modifier] 
    construct T1  [stringlit]
        _  [ quote  N1 ] 
    construct T2  [stringlit]
        _  [ quote  N2 ] 
    where
        T1  [>  T2]
    by
        N2  N1  Rest 
end rule

rule normalise_list_throws_qualified_name
    replace  [list qualified_name +]
        N1  [qualified_name] ,  N2  [qualified_name] ,  Rest  [list qualified_name +] 
    construct T1  [stringlit]
        _  [ quote  N1 ] 
    construct T2  [stringlit]
        _  [ quote  N2 ] 
    where
        T1  [>  T2]
    by
        N2 ,  N1 ,  Rest 
end rule

rule normalise_list_annotation_value_list_keyed_annotation_value
    replace  [list keyed_annotation_value]
        N1  [keyed_annotation_value] ,  N2  [keyed_annotation_value] ,  Rest  [list keyed_annotation_value] 
    construct T1  [stringlit]
        _  [ quote  N1 ] 
    construct T2  [stringlit]
        _  [ quote  N2 ] 
    where
        T1  [>  T2]
    by
        N2 ,  N1 ,  Rest 
end rule

rule normalise_list_single_annotation_value_expression_or_nested_annotation
    replace  [list expression_or_nested_annotation]
        N1  [expression_or_nested_annotation] ,  N2  [expression_or_nested_annotation] ,  Rest  [list
          expression_or_nested_annotation] 
    construct T1  [stringlit]
        _  [ quote  N1 ] 
    construct T2  [stringlit]
        _  [ quote  N2 ] 
    where
        T1  [>  T2]
    by
        N2 ,  N1 ,  Rest 
end rule

function normalise_ignore_by1_SingleLine_comment_nl_mycomment1 E1  [comment_nl] N1  [mycomment]
    replace  [mycomment *]
        Seq  [mycomment *] 
    where not
        E1  [SingleLine  N1]
    by
        Seq  [ . N1 ] 
end function

function normalise_ignore_by2_SingleLine_comment_nl_mycomment1 E1  [comment_nl] N1  [mycomment]
    replace  [mycomment *]
        Seq  [mycomment *] 
    where
        E1  [SingleLine  N1]
    by
        Seq 
end function

function normalise_ignore_by3_SingleLine_comment_nl_mycomment1 E1  [comment_nl]
    replace  [comment_nl *]
        Seq  [comment_nl *] 
    deconstruct E1
        N1  [repeat mycomment] 
    construct N2  [mycomment *]
        _  [normalise_ignore_by1_SingleLine_comment_nl_mycomment1  E1  each  N1]  [
                  normalise_ignore_by2_SingleLine_comment_nl_mycomment1  E1  each  N1]
 
    construct E2  [comment_nl]
        N2 
    by
        Seq  [ . E2 ] 
end function

function nonempty2 Term  [comment_nl]
    replace  [comment_nl *]
        List1  [comment_nl *] 
    deconstruct not Term

    by
        _  [ . List1 ]  [ . Term ] 
end function

function normalise_ignore_by4_SingleLine_comment_nl_mycomment1
    replace  [program]
        P1  [ program ] 
    construct List1  [comment_nl *]
        _  [ ^  P1 ] 
    construct List3  [comment_nl *]
        _  [nonempty2  each  List1]
 
    construct List2  [comment_nl *]
        _  [normalise_ignore_by3_SingleLine_comment_nl_mycomment1  each  List1]
 
    construct P2  [program]
        P1  [$  each  List3  List2]
 
    by
        P2 
end function

function program_normalise
    replace  [program]
        Prg  [ program ] 
    by
        Prg  [ normalise_ignore_by4_modifier_annotation1 ]  [ normalise_ignore_by4_package_declaration_import_declaration2 ]  [ 
          normalise_ignore_by4_NotModel_class_or_interface_body_class_body_declaration1 ]  [ 
          normalise_ignore_by4_SingleLine_comment_nl_mycomment1 ]  [ normalise_list_class_header_modifier ]  [ 
          normalise_list_interface_header_modifier ]  [ normalise_list_enum_header_modifier ]  [ 
          normalise_list_extends_clause_type_name ]  [ normalise_list_implements_clause_qualified_name ]  [ 
          normalise_list_constructor_declaration_modifier ]  [ normalise_list_variable_declaration_modifier ]  [ 
          normalise_list_variable_declarators_variable_declarator ]  [ normalise_list_method_declaration_modifier ]  [ 
          normalise_list_throws_qualified_name ]  [ normalise_list_annotation_value_list_keyed_annotation_value ]  [ 
          normalise_list_single_annotation_value_expression_or_nested_annotation ] 
end function

function program_remove_clone
    replace  [program]
        Prg  [ program ] 
    export CloneNumber [number]
        0 
    import TXLargs [repeat stringlit]

    deconstruct * TXLargs
        "-diff"  Filename  [ stringlit ] 
    export CloneNumber
        99 
    construct P2  [program]
        _  [ read  Filename ]  [ program_normalise ] 
    export Program_Diff [program]
        P2 
    by
        Prg  [ find_replace_package_header ]  [ find_replace_type_declaration ]  [ find_replace_class_body_declaration ]  [ 
          find_replace_mycomment ] 
end function

redefine program
    ...
|       
    [empty]  |  [attr number] 

end define
function print_diff_1
    replace  [program]
        Prg  [ program ] 
    import TXLinput [stringlit]

    construct Str_TmpFile  [stringlit]
        TXLinput  [ +  ".tmp" ] 
    construct Str_RmTmpFile  [stringlit]
        _  [ +  "/bin/rm -f " ]  [ +  Str_TmpFile ] 
    construct P2  [program]
        Prg  [ write  Str_TmpFile ]  [ read  Str_TmpFile ]  [ system  Str_RmTmpFile ] 
    construct S_Diff  [stringlit]
        _  [ quote  P2 ] 
    where not
        S_Diff  [=  ""]
    by
        Prg 
end function

function print_diff_2
    replace  [program]
        Prg  [ program ] 
    import TXLinput [stringlit]

    construct Str_TmpFile  [stringlit]
        TXLinput  [ +  ".tmp" ] 
    construct Str_RmTmpFile  [stringlit]
        _  [ +  "/bin/rm -f " ]  [ +  Str_TmpFile ] 
    construct P2  [program]
        Prg  [ program_normalise ]  [ write  Str_TmpFile ]  [ read  Str_TmpFile ]  [ system  Str_RmTmpFile ] 
    construct S_Diff  [stringlit]
        _  [ quote  P2 ] 
    where
        S_Diff  [=  ""]
    by
        _ 
end function

function print_diff
    replace  [program]
        P_diff  [ program ] 
    import CloneNumber [number]

    import Program_Diff [program]

    where
        CloneNumber  [>  0]
    construct P_Clone  [program]
        CloneNumber  [ -  99 ] 
    construct P_Left  [program]
        P_diff  [ print_diff_1 ]  [ print_diff_2 ]  [ printattr ] 
    construct P_Right  [program]
        Program_Diff  [ print_diff_1 ]  [ print_diff_2 ]  [ printattr ] 
    by
        P_Clone 
end function

function main
    replace  [program]
        Prg  [ program ] 
    export Program_Diff [program]
        _ 
    export Program [program]
        Prg 
    by
        Prg  [ program_normalise ]  [ program_remove_clone ]  [ print_diff ] 
end function

