tokens
    id                 "[$\u][$\i]*"
    bool               "true"
               |       "false"
end tokens

keys
    'cycle  'rec  'if  'then  'else  'let  'llet  'in  'and  'or  'not  'isempty  'isint  'isbool  'isstring  'islabel  'isfloat
end keys

define aexpr
    '{ '} 
    |    '( ') 
    |    '{ [IN]
        [alpat_aexpr_list]  [EX] [NL]
    [SPOFF]  '}  [SPON] 
    |    '( [IN] [NL]
        [aexpr_list]  [EX] [NL]
    ') 
    |    'cycle( [aexpr]  ') 
    |    'doc( [stringlit]  ') 
    |    'if  [abexpr]  'then  [aexpr]  'else  [aexpr] 
    |    'rec( '\  '( [aexpr_rec_core] 
    |    'let  [variable]  '=  [aexpr]  'in  [aexpr] 
    |    'llet  [label_variable]  '=  [alpat]  'in  [aexpr] 
    |    [marker] 
    |    [variable] 
    |    [marker]  ':=  [aexpr] 
    |    [allit] 
    |    [aexpr]  '@  [aexpr] 
    |    [aexpr]  'U  [aexpr] 
    |    [aexpr]  '++  [aexpr] 
end define
define alpat_aexpr_list
    [alpat_aexpr,+] 
end define
define alpat_aexpr
    [alpat] 
    |    [NL]
    [alpat]  [SPOFF]  ':  [SPON]  [aexpr] 
end define
define aexpr_list
    [aexpr,+] 
end define
define aexpr_rec_core
    [label_variable]  ',  [variable]  ')  '. [aexpr]  ')  '( [aexpr]  ') 
end define
define alpat
    [label_variable] 
    |    [allit] 
    |    '( [alpat]  ') 
    |    [alpat]  '+  [alpat] 
    |    [alpat]  '-  [alpat] 
    |    [alpat]  '*  [alpat] 
    |    [alpat]  '/  [alpat] 
    |    [alpat]  '^  [alpat] 
end define
define alptype
    'isint 
    |    'isbool 
    |    'isstring 
    |    'islabel 
    |    'isfloat 
end define
define abexpr
    'isempty  '( [aexpr]  ') 
    |    [alptype]  '( [alpat]  ') 
    |    'not  [abexpr] 
    |    [abexpr]  'and  [abexpr] 
    |    [abexpr]  'or  [abexpr] 
    |    [alpat_alcmp_alpat] 
    |    [bool] 
    |    '( [abexpr]  ') 
end define
define alpat_alcmp_alpat
    [alpat]  '=  [alpat] 
    |    [alpat]  '<  [alpat] 
    |    [alpat]  '>  [alpat] 
end define
define label_variable
    [id] 
end define
define variable
    '$db 
    |    '$  [id] 
end define
define allit
    [id] 
    |    [number] 
    |    [bool] 
    |    [stringlit] 
    |    '! 
    |    '? 
end define
define marker
    [SPOFF]  '&  [id]  [SPON] 
end define
comments
    (*  *)
end comments

define program
    [aexpr] 
end define
keys
    <<<<<<  >>>>>> 
end keys

compounds
    <<<<<<  >>>>>> 
end compounds

define Change
            [NL]
    <<<<<<  [opt stringlit]  [NL]
    |  [NL]
    >>>>>>  [opt stringlit]  [NL]
 
end define
function program_normalise
    replace  [program]
        Prg  [ program ] 
    by
        Prg 
end function

function program_remove_clone
    replace  [program]
        Prg  [ program ] 
    export CloneNumber [number]
        0 
    import TXLargs [repeat stringlit]

    deconstruct * TXLargs
        "-diff"  Filename  [ stringlit ] 
    export CloneNumber
        99 
    construct P2  [program]
        _  [ read  Filename ]  [ program_normalise ] 
    export Program_Diff [program]
        P2 
    by
        Prg 
end function

redefine program
    ...
|       
    [empty]  |  [attr number] 

end define
function print_diff_1
    replace  [program]
        Prg  [ program ] 
    import TXLinput [stringlit]

    construct Str_TmpFile  [stringlit]
        TXLinput  [ +  ".tmp" ] 
    construct Str_RmTmpFile  [stringlit]
        _  [ +  "/bin/rm -f " ]  [ +  Str_TmpFile ] 
    construct P2  [program]
        Prg  [ write  Str_TmpFile ]  [ read  Str_TmpFile ]  [ system  Str_RmTmpFile ] 
    construct S_Diff  [stringlit]
        _  [ quote  P2 ] 
    where not
        S_Diff  [=  ""]
    by
        Prg 
end function

function print_diff_2
    replace  [program]
        Prg  [ program ] 
    import TXLinput [stringlit]

    construct Str_TmpFile  [stringlit]
        TXLinput  [ +  ".tmp" ] 
    construct Str_RmTmpFile  [stringlit]
        _  [ +  "/bin/rm -f " ]  [ +  Str_TmpFile ] 
    construct P2  [program]
        Prg  [ program_normalise ]  [ write  Str_TmpFile ]  [ read  Str_TmpFile ]  [ system  Str_RmTmpFile ] 
    construct S_Diff  [stringlit]
        _  [ quote  P2 ] 
    where
        S_Diff  [=  ""]
    by
        _ 
end function

function print_diff
    replace  [program]
        P_diff  [ program ] 
    import CloneNumber [number]

    import Program_Diff [program]

    where
        CloneNumber  [>  0]
    construct P_Clone  [program]
        CloneNumber  [ -  99 ] 
    construct P_Left  [program]
        P_diff  [ print_diff_1 ]  [ print_diff_2 ]  [ printattr ] 
    construct P_Right  [program]
        Program_Diff  [ print_diff_1 ]  [ print_diff_2 ]  [ printattr ] 
    by
        P_Clone 
end function

function main
    replace  [program]
        Prg  [ program ] 
    export Program_Diff [program]
        _ 
    export Program [program]
        Prg 
    by
        Prg  [ program_normalise ]  [ program_remove_clone ]  [ print_diff ] 
end function

